VERSION 5.00
Begin VB.Form Form1 
   BackColor       =   &H00E0E0E0&
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   4005
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   6930
   ClipControls    =   0   'False
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   9.75
      Charset         =   204
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   267
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   462
   StartUpPosition =   2  'CenterScreen
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type Vector
  x As Single
  y As Single
End Type

Dim v(255) As Vector, vCnt As Long

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
  If Button = 1 Then
    If vCnt > 255 Then vCnt = 0
    v(vCnt) = V2Create(x, y)
    vCnt = vCnt + 1
  ElseIf Button = 2 Then
    vCnt = 0
  End If
  Draw
End Sub

Private Sub Draw()
  Dim n As Long
  Dim v1 As Vector, v2 As Vector

  Cls
  If vCnt = 0 Then Exit Sub
  For n = 0 To vCnt - 2
    Circle (v(n).x, v(n).y), 3, &HFF
    If n > 0 Then
      v1 = v(n - 1)
    Else
      v1 = V2Add(v(0), V2Sub(v(0), v(1)))
    End If
    If n < vCnt - 2 Then
      v2 = v(n + 2)
    Else
      v2 = V2Add(v(n + 1), V2Sub(v(n + 1), v(n)))
    End If
    DrawLine v1, v(n), v(n + 1), v2
  Next n
  Circle (v(vCnt - 1).x, v(vCnt - 1).y), 3, &HFF
End Sub

Private Sub DrawLine(iv1 As Vector, iv2 As Vector, iv3 As Vector, iv4 As Vector)
  Dim i As Long, s As Single
  Dim L1 As Single, L2 As Single, L3 As Single
  Dim v1 As Vector, v2 As Vector, v3 As Vector
  Dim tv1 As Vector, tv2 As Vector
  Dim NewV As Vector

  v1 = V2Sub(iv2, iv1)
  v2 = V2Sub(iv3, iv2)
  v3 = V2Sub(iv4, iv3)
  L1 = V2Len(v1)
  L2 = V2Len(v2)
  L3 = V2Len(v3)
  tv1 = V2Scale(V2Norm(V2Add(V2Scale(v1, L2 / L1), V2Scale(v2, L1 / L2))), 0.5 * L2)
  tv2 = V2Scale(V2Norm(V2Add(V2Scale(v2, L3 / L2), V2Scale(v3, L2 / L3))), 0.5 * L2)
  For i = 0 To L2 - 1
    s = i / L2
    v1 = V2Add(iv2, V2Scale(tv1, s))
    v2 = V2Sub(iv3, V2Scale(tv2, 1 - s))
    NewV = V2Lerp(v1, v2, FN(s))
    PSet (NewV.x, NewV.y), 0
  Next i
End Sub

Private Function FN(ByVal x As Single) As Single
  FN = (x * x - 1) ^ 2
End Function

Private Function V2Norm(v1 As Vector) As Vector
  V2Norm = V2Scale(v1, 1 / V2Len(v1))
End Function

Private Function V2Create(ByVal x As Single, ByVal y As Single) As Vector
  V2Create.x = x
  V2Create.y = y
End Function

Private Function V2Add(v1 As Vector, v2 As Vector) As Vector
  V2Add.x = v1.x + v2.x
  V2Add.y = v1.y + v2.y
End Function

Private Function V2Sub(v1 As Vector, v2 As Vector) As Vector
  V2Sub.x = v1.x - v2.x
  V2Sub.y = v1.y - v2.y
End Function

Private Function V2Scale(v1 As Vector, s As Single) As Vector
  V2Scale.x = v1.x * s
  V2Scale.y = v1.y * s
End Function

Private Function V2Lerp(v1 As Vector, v2 As Vector, s As Single) As Vector
  V2Lerp.x = v1.x * s + v2.x * (1 - s)
  V2Lerp.y = v1.y * s + v2.y * (1 - s)
End Function

Private Function V2Len(v1 As Vector) As Single
  V2Len = Sqr(v1.x * v1.x + v1.y * v1.y)
End Function

Private Function V2LenSq(v1 As Vector) As Single
  V2LenSq = v1.x * v1.x + v1.y * v1.y
End Function

Private Sub Form_Load()
  Me.Move Me.Left, Me.Top, Me.Width - Screen.TwipsPerPixelX * (Me.ScaleWidth - 800), Me.Height - Screen.TwipsPerPixelY * (Me.ScaleHeight - 600)
End Sub
